﻿
Partial Class FinancialCalculator
    Inherits System.Web.UI.Page

    Private Function ComputeMonthlyCost(ByVal principal As Decimal, ByVal rate As Decimal, ByVal totalTime As Decimal) As Decimal
        'Specify constant values
        Const INTEREST_CALCS_PER_YEAR As Integer = 12
        Const PAYMENTS_PER_YEAR As Integer = 12

        Dim ratePerPeriod As Decimal
        ratePerPeriod = rate / INTEREST_CALCS_PER_YEAR

        Dim payPeriods As Integer
        payPeriods = totalTime * PAYMENTS_PER_YEAR

        Dim annualRate As Decimal
        annualRate = Math.Exp(INTEREST_CALCS_PER_YEAR * Math.Log(1 + ratePerPeriod)) - 1

        Dim intPerPayment As Decimal
        intPerPayment = (Math.Exp(Math.Log(annualRate + 1) / payPeriods) - 1) * payPeriods

        'Now, compute the total cost of the loan
        Dim intPerMonth As Decimal = intPerPayment / PAYMENTS_PER_YEAR

        Dim costPerMonth As Decimal
        costPerMonth = principal * intPerMonth / (1 - Math.Pow(intPerMonth + 1, -payPeriods))

        Return costPerMonth
    End Function

    Protected Sub PerformCalcButton_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles PerformCalcButton.Click
        'Create variables to hold the values entered by the user
        Dim loanPrincipal As Decimal = LoanAmount.Text
        Dim loanRate As Decimal = InterestRate.Text / 100
        Dim totalTime As Decimal = MortgageLength.Text

        Results.Text = "Your mortgage payment per month is $" & ComputeMonthlyCost(LoanPrincipal, LoanRate, TotalTime)
    End Sub
End Class
